#pragma once

#include "common.h"
#include "Context.h"
class HField;
class BMPacket;

namespace WorldMachine {
/**
Basic utility methods to resampling a bitmap or heightfield to a new resolution.

THese have been supersceded in WM 2.9.0 by the new resampling methods.
*/
class Rescaler
{
public:
	Rescaler(void);
	~Rescaler(void);

	static Coord LimitSize(const Coord &size, int limit);
	static Coord LimitSize(const Coord &size, const Coord &limit); // optimally make sure we fit to a rectangle-sized limit

	static HFPointer RescaleHF(HFPointer input, Coord  dims);		///< Rescale input heightfield to the given dimensions and return new one
	static HFPointer RescaleHF(HFPointer input, PacketContext &dims);	///< Rescale input heightfield to the given dimensions and return new one

	static BMPointer RescaleBMP(BMPointer input, Coord  dims);		///< Rescale input bitmap to the given dimensions and return new one
	static BMPointer RescaleBMP(BMPointer input, PacketContext &dims);	///< Rescale input bitmap to the given dimensions and return new one

	static void Nearest2(HField &src, HField &dest);
	static void Bilinear2(HField &src, HField &dest);
	static void Bicubic2(HField &src, HField &dest);
	static void BilinearBMP(BMPacket &src, BMPacket &dest);

protected:
    
};

}